
import java.awt.*;
import java.awt.font.*;
import java.io.*;
import java.text.SimpleDateFormat;
import java.text.DateFormat;
import java.awt.geom.*;
import java.awt.event.*;
import java.text.AttributedString;
import java.text.AttributedCharacterIterator;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.io.File;
import java.io.InputStream;
import java.io.FileInputStream;
import java.io.BufferedInputStream;
import java.util.Vector;
import java.util.Properties;

public class Tabla_Botones extends JPanel {

    Vector discos = new Vector();
    int num;
    JButton BAgregar,BEliminar,BDetalles,BPrestar,BDevolver, loopB, BActualizar;
    JTable table;
    Properties P_eventos;
    Contenido_Frame Contenido_Frame;
    String errStr;
    String NombreArchivo =new String();

 
    public Tabla_Botones(String dirName) {
        setLayout(new BorderLayout());   		//se arregle el tamao de las componentes
//        setBorder(new EmptyBorder(50,50,50,50));	//borde vacio

        if (dirName != null) {
            loadTabla_Botones(dirName); 
        }
	Contenido_Frame = new Contenido_Frame();
	add(Contenido_Frame);
    }

    public void loadTabla_Botones(String name) {
        try {
            File file = new File(name);
            if (file != null && file.isDirectory()) {
                String files[] = file.list();
                for (int i = 0; i < files.length; i++) {
                    File leafFile = new File(file.getAbsolutePath(), files[i]);
                    if (leafFile.isDirectory()) {
                        loadTabla_Botones(leafFile.getAbsolutePath());
                    } else {
                        addDisco(leafFile);
                    }
                }
            } else if (file != null && file.exists()) {
                addDisco(file);
            }
        } catch (SecurityException ex) {
            reportStatus(ex.toString());
        } catch (Exception ex) {
            reportStatus(ex.toString());
        }
    }

    private void addDisco(File file) {
        String s = file.getName().toLowerCase();
        if (s.endsWith(".dat"))  discos.add(file);        
    }

    private void reportStatus(String msg) {
        if ((errStr = msg) != null) {
            System.out.println(errStr);
        }
    }


    class Contenido_Frame extends JPanel implements ActionListener {

        TableModel dataModel;
        JFrame frame;
        JTextField textField;
        JButton applyB;

        public Contenido_Frame() {
            setLayout(new BorderLayout());
            setPreferredSize(new Dimension(260,300));

            final String[] names = { "#", "Nombre" };
    
            dataModel = new AbstractTableModel() {
                public int getColumnCount() { return names.length; }
                public int getRowCount() { return discos.size();}
                public Object getValueAt(int row, int col) { 
                    if (col == 0) {
                        return new Integer(row);
                    } else if (col == 1) {
                        Object object = discos.get(row);
                        if (object instanceof File) {
                            return ((File) object).getName();
                        } 
                    } 
                    return null;
                }
                public String getColumnName(int col) {return names[col]; }
                public Class getColumnClass(int c) {
                    return getValueAt(0, c).getClass();
                }
                public boolean isCellEditable(int row, int col) {
                    return false;
                }
///////////////////////////////////
                public void setValueAt(Object aValue, int row, int col) {
                }
            };
    
            table = new JTable(dataModel);
//            table.setSelectionForeground(new Color(51,204,204));
            TableColumn col = table.getColumn("#");
            col.setMaxWidth(20);
            table.sizeColumnsToFit(0);

            JScrollPane scrollPane = new JScrollPane(table);
//            EmptyBorder eb = new EmptyBorder(5,5,5,5);
//            scrollPane.setBorder(new CompoundBorder(eb,new EtchedBorder()));
            add(scrollPane);

            JPanel p1 = new JPanel();
            p1.setBackground(new Color(51,204,204));
	    p1.setLayout(new BoxLayout(p1, BoxLayout.X_AXIS));	

            BAgregar = addButton("Agregar", p1);
            BAgregar.setToolTipText("Agrega nuevos CDs");
            BAgregar.setBackground(Color.orange);

            BActualizar = addButton("Actualizar", p1);
            BActualizar.setToolTipText("Actualiza la tabla");
            BActualizar.setBackground(Color.orange);


            BEliminar = addButton("Eliminar", p1);
            BEliminar.setToolTipText("Elimina el CD seleccionado");
            BEliminar.setBackground(Color.orange);

            JPanel p0 = new JPanel(new BorderLayout());
            p0.setBackground(new Color(51,204,204));
	    p0.setLayout(new BoxLayout(p0, BoxLayout.Y_AXIS));	
 	    p0.setBorder(new EmptyBorder(5,0,5,0));	/////////////////////////////sup , izq, inf ,derecha

	    BDetalles = addButton("Detalles", p0);
            BDetalles.setToolTipText("Modifica/Muestra la descripcion del CD");
            BDetalles.setBackground(Color.orange);

	    BPrestar = addButton("Prestar ", p0);
            BPrestar.setToolTipText("Registra el prestamo");
            BPrestar.setBackground(Color.orange);

	    BDevolver = addButton("Devolver", p0);
            BDevolver.setToolTipText("Actualiza la Devolucion");
            BDevolver.setBackground(Color.orange);

            add("South", p1);
            add("East", p0);
        }

        
        private JButton addButton(String name, JPanel p) {
            JButton b = new JButton(name);
            b.addActionListener(this);
            p.add(b);
            return b;
        }

 
        private void doFrame(String titleName) {
            int w = 500;
            int h = 130;
            JPanel panel = new JPanel(new BorderLayout());
            JPanel p1 = new JPanel();
            if (titleName.endsWith("URL")) {
                p1.add(new JLabel("URL :"));
                textField = new JTextField("http://foo.bar.com/foo.wav");
                textField.addActionListener(this);
            } else {
                p1.add(new JLabel("File or Dir :"));
                String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
                String text = null;
                try {
                    text = System.getProperty("user.dir") + sep;
                } catch (SecurityException ex) {
                    reportStatus(ex.toString());

                    return;
                }
                textField = new JTextField(text);
                textField.setPreferredSize(new Dimension(w-100, 30));
                textField.addActionListener(this);
            }
            p1.add(textField);
            panel.add(p1);
            JPanel p2 = new JPanel();
            p2.setBackground(new Color(51,204,204));
            applyB = addButton("Apply", p2);
            addButton("Cancel", p2);
            panel.add("South", p2);
            panel.setBackground(new Color(50,204,204));
            frame = new JFrame(titleName);
            frame.getContentPane().add("Center", panel);
            frame.pack();
            Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
            frame.setLocation(d.width/2 - w/2, d.height/2 - h/2);
            frame.setSize(w, h);
            frame.setVisible(true);
        }

        public void ActualizarTabla() 
        {
                    discos.clear();
                    tableChanged();
                String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
                String text = null;
                try {
                    text = System.getProperty("user.dir") + sep;
                } catch (SecurityException ex) {
                    reportStatus(ex.toString());

                    return;
                }
                        loadTabla_Botones(text);

        }

        public void actionPerformed(ActionEvent e) 
        {
            Object object = e.getSource();
            if (object instanceof JTextField) 
            {
                applyB.doClick();
            } 
            else if (object instanceof JButton) 
            {
                JButton button = (JButton) e.getSource();
                if (button.getText().equals("Apply")) 
                {
                   String name = textField.getText().trim();
                   tableChanged();
                } 
                else if (button.getText().equals("Cancel")) 
                {
                    frame.dispose();
                    frame = null;
                    errStr = null;
                } 
                else if (button.getText().equals("Eliminar")) 
                {
                    num = table.getSelectedRow();
                    String sep = String.valueOf(System.getProperty("file.separator").toCharArray()[0]);
                    String text = null;
                    try {
                        text = (System.getProperty("user.dir") + sep)+table.getValueAt(num , 1);;
                    } catch (SecurityException ex) {
                        System.out.println(ex.toString());
                        return;
                    }
                    System.out.println(text);
                    File file = new File (text);
                    file.delete();
                    int rows[] = table.getSelectedRows();	//obtiene las columnas seeccionadas
                    Vector tmp = new Vector();
                    for (int i = 0; i < rows.length;i++) {
                        tmp.add(discos.get(rows[i]));
                    }
                    discos.removeAll(tmp);
                    tableChanged();
                }
                else if (button.getText().equals("Detalles")) {	//////////////DETALLES
                  num = table.getSelectedRow();
                  num = num == -1 ? 0 : num;
                  NombreArchivo=""+table.getValueAt(num , 1);
                 Prestar P_frame = new Prestar("Detalles",NombreArchivo);
                  P_frame.setVisible(true); 
                }
                else if (button.getText().equals("Devolver")) {	////////////////DEVOLVER
                  num = table.getSelectedRow();
                  num = num == -1 ? 0 : num;
                  String NombreArchivo =new String();
                  NombreArchivo=""+table.getValueAt(num , 1);
                  Devolver D_frame = new Devolver( NombreArchivo);
                  D_frame.setVisible(true); 
                }
                else if (button.getText().equals("Agregar")) {
                  Agregar A_frame = new Agregar(this);
                  A_frame.setVisible(true); 
                }
                  else if (button.getText().equals("Prestar ")) {    	////////PRESTAR
                  num = table.getSelectedRow();
                  num = num == -1 ? 0 : num;
                  NombreArchivo=""+table.getValueAt(num , 1);
                  Prestar P_frame = new Prestar("Prestar",NombreArchivo);
                  P_frame.setVisible(true); 
                }
                 else if (button.getText().equals("Actualizar")) {
                   ActualizarTabla();}
                }
           }
       public void tableChanged() {
       table.tableChanged(new TableModelEvent(dataModel));

        }//end actionperformed

    }  // End Contenido_Frame



    public static void main(String args[]) {
        String media = "media";
        final Tabla_Botones Tabla_Botones = new Tabla_Botones(args.length == 0 ? media : args[0]);
        JFrame f = new JFrame();
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {System.exit(0);}
        });

        f.getContentPane().add("Center", Tabla_Botones);
        f.pack();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        int w = 750;
        int h = 340;
        f.setLocation(screenSize.width/2 - w/2, screenSize.height/2 - h/2);
        f.setSize(w, h);
        f.setVisible(true);
        if (args.length > 0) {
            File file = new File(args[0]);
            if (file == null && !file.isDirectory()) {
                System.out.println("usage: java Tabla_Botones audioDirectory");
            } 
        }
    }
} 
